#
from enigma import *
from Screens.Screen import Screen
from Screens.Standby import Standby
from Screens.MessageBox import MessageBox
from Screens.InputBox import InputBox
from Screens.ChoiceBox import ChoiceBox
from Components.ActionMap import ActionMap, NumberActionMap
from Components.ScrollLabel import ScrollLabel
from Components.GUIComponent import *
from Components.MenuList import MenuList
from Components.Input import Input
from Screens.Console import Console
from Plugins.Plugin import PluginDescriptor
from Screens.ImageWizard import ImageWizard
from Plugins.Plugin import PluginDescriptor
from Screens.Standby import Standby

import os
import time

sleeptimer_pluginversion = "3.2"
messagefile = "/var/tmp/message.txt"


message_started = "/var/tmp/.stmessage" 

def main(session,**kwargs):
    try:    
     	session.open(Sleeptimer)
    except:
        print "[Sleeptimer] Pluginexecution failed"

def autostart(reason,**kwargs):
    if reason == 0:
        print "[Sleeptimer] no autostart"

def Plugins(**kwargs):
    return PluginDescriptor(
        name="Sleeptimer / Message Box",
        description="start Sleeptimer and Message Box", 
        where = PluginDescriptor.WHERE_PLUGINMENU,
        fnc = main
        )

class Sleeptimer(Screen):
    skin = """
        <screen position="100,100" size="500,400" title="Sleeptimer and Message Box Menu" >
            <widget name="menu" position="10,10" size="490,390" scrollbarMode="showOnDemand" />
        </screen>"""
        
    def __init__(self, session, args = 0):
        self.skin = Sleeptimer.skin
        self.session = session
        Screen.__init__(self, session)
        self.menu = args
        list = []
        list.append(("Standby after 1 min", "standby1"))        
        list.append(("Standby after 10 min", "standby10"))        
        list.append(("Standby after 30 min", "standby30"))        
        list.append(("Standby after 60 min", "standby60"))        
        list.append(("Standby after 90 min", "standby90"))        
        list.append(("Standby after 120 min", "standby120"))        
        list.append(("Deep Standby after 1 min", "deepstandby1"))        
        list.append(("Deep Standby after 10 min", "deepstandby10"))        
        list.append(("Deep Standby after 30 min", "deepstandby30"))        
        list.append(("Deep Standby after 60 min", "deepstandby60"))        
        list.append(("Deep Standby after 90 min", "deepstandby90"))        
        list.append(("Deep Standby after 120 min", "deepstandby120"))        
        list.append(("Message box enable/disable", "messagebox"))        
        list.append(("Message box send Testmessage", "testms"))        
        list.append(("about", "aboutplugin"))        
        self["menu"] = MenuList(list)
        self["actions"] = ActionMap(["WizardActions", "DirectionActions"],{"ok": self.gostandby,"back": self.close,}, -1)
        
    def gostandby(self):
        returnValue = self["menu"].l.getCurrentSelection()[1]
        if returnValue is not None:
           if returnValue is "standby1":
		SleepTimer(self,1,1)
           elif returnValue is "aboutplugin":
		self.session.open(MessageBox,"Sleeptimer and Message Box Enigma2 Plugin %s\n\nSleeptimer by aladin25\n\nMessage Box by thowi\n\nPlugin by gutemine" % sleeptimer_pluginversion, MessageBox.TYPE_INFO)
           elif returnValue is "standby10":
		SleepTimer(self,10,1)
           elif returnValue is "standby30":
		SleepTimer(self,30,1)
           elif returnValue is "standby60":
		SleepTimer(self,60,1)
           elif returnValue is "standby90":
		SleepTimer(self,90,1)
           elif returnValue is "standby120":
		SleepTimer(self,120,1)
           elif returnValue is "deepstandby1":
		SleepTimer(self,1,2)
           elif returnValue is "deepstandby10":
		SleepTimer(self,10,2)
           elif returnValue is "deepstandby30":
		SleepTimer(self,30,2)
           elif returnValue is "deepstandby60":
		SleepTimer(self,60,2)
           elif returnValue is "deepstandby90":
		SleepTimer(self,90,2)
           elif returnValue is "deepstandby120":
		SleepTimer(self,120,2)
           elif returnValue is "messagebox":
		PopUpMessage(self)
           elif returnValue is "testms":
                os.system("echo Testmessage > %s" % messagefile)

class SleepTimer(Screen):
	def __init__(self,Menu,Sec,Mode):
		Screen.__init__(self,Menu.session)
		self.session = Menu.session
		self.Mode = Mode
	
		if (Mode == 1):
			if (Sec == 1):
				self.Mes = "Standby in " + str(Sec) + " minute"
			else:
				self.Mes = "Standby in " + str(Sec) + " minutes"
		else:
			if (Sec == 1):
				self.Mes = "Deep Standby in " + str(Sec) + " minute."
			else:
				self.Mes = "Deep Standby in " + str(Sec) + " minutes."

		self.Timer = eTimer()
		self.Timer.stop()
		self.Timer.timeout.get().append(self.OffTimer)
		self.Timer.start(Sec*60000,True);
		
		self.Timer2 = eTimer()
		self.Timer2.stop()
		if (Sec > 2):
			self.Timer2.timeout.get().append(self.Warnung)
			self.Timer2.start((Sec-2)*60000,True)
			
		self.Timer3 = eTimer()
		self.Timer3.stop()
		self.Timer3.timeout.get().append(self.InfoBox)
		self.Timer3.start(100,True)
			
	def InfoBox(self):
		self.Timer3.stop()
		self.session.open(MessageBox,self.Mes,type = MessageBox.TYPE_INFO,timeout = 10)
		
	def CheckStop(self,retval):
		if (not(retval)):
			self.Timer.stop()
		
	def Warnung(self):
		self.Timer2.stop()
		self.session.openWithCallback(self.CheckStop,MessageBox,"turn off in 2 minutes is OK ?",type = MessageBox.TYPE_YESNO,timeout = 90)		
		
	def OffTimer(self):		
		self.Timer.stop()
		if (self.Mode == 1):
			self.session.open(Standby,self);
		else:
			quitMainloop(1);


class PopUpMessage(Screen):
	def __init__(self,Menu):
		Screen.__init__(self,Menu.session)
		self.session = Menu.session
	
		self.Timer4 = eTimer()
		self.Timer4.stop()
		self.Timer4.timeout.get().append(self.InfoBox2)
		self.Timer4.start(1000,True)
                if os.path.exists(message_started) == True:
                   os.system("rm %s" % message_started)
		   self.session.open(MessageBox,"Message Box disabled !",type = MessageBox.TYPE_INFO)
                else:
                   os.system("touch %s" % message_started)
		   self.session.open(MessageBox,"Message Box enabled ! \nExisting %s will be displayed" % messagefile,type = MessageBox.TYPE_INFO)
			
	def InfoBox2(self):
		self.Timer4.stop()

                if os.path.exists(messagefile) == True:
                   fp = open(messagefile,"r")
                   line = fp.readline()
                   fp.close()
                   os.system("rm %s" % messagefile)
	   	   self.session.open(MessageBox,"%s" % line ,type = MessageBox.TYPE_INFO,timeout = 20)

# restart timer for checking if message needs to be displayed in 1 sec
 
                   if os.path.exists(message_started) == True:
	              self.Timer4.start(20000,True)
                else:
                   if os.path.exists(message_started) == True:
	              self.Timer4.start(1000,True)
		
